
<!DOCTYPE html>
<!--[if IEMobile 7 ]><html class="no-js iem7"><![endif]-->
<!--[if lt IE 9]><html class="no-js lte-ie8"><![endif]-->
<!--[if (gt IE 8)|(gt IEMobile 7)|!(IEMobile)|!(IE)]><!--><html class="no-js" lang="en"><!--<![endif]-->
<head>
  <meta charset="utf-8">
  <title>Space Vatican</title>
  <meta name="author" content="Frederick Cheung">

  
  <meta name="description" content="I&rsquo;ve been using sorbet recently on a project. If you haven&rsquo;t come across it before, sorbet is a type checker for ruby that allows you to &hellip;">
  

  <!-- http://t.co/dKP3o1e -->
  <meta name="HandheldFriendly" content="True">
  <meta name="MobileOptimized" content="320">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  
  <link rel="canonical" href="https://www.spacevatican.org/">
  <link href="/favicon.png" rel="icon">
  <link href="/stylesheets/screen.css" media="screen, projection" rel="stylesheet" type="text/css">
  <script src="/javascripts/all.js" type="text/javascript"></script>
  <script src="/javascripts/stackoverflow.js" type="text/javascript"></script>
  <link href="/atom.xml" rel="alternate" title="Space Vatican" type="application/atom+xml">
  <!--Fonts from Google"s Web font directory at http://google.com/webfonts -->
<link href="https://fonts.googleapis.com/css?family=PT+Serif:regular,italic,bold,bolditalic" rel="stylesheet" type="text/css">
<link href="https://fonts.googleapis.com/css?family=PT+Sans:regular,italic,bold,bolditalic" rel="stylesheet" type="text/css">

  
  <script type="text/javascript">
    var _gaq = _gaq || [];
    _gaq.push(['_setAccount', 'UA-32392818-1']);
    
      _gaq.push(['_setDomainName', 'spacevatican.org']);
    
    
    _gaq.push(['_trackPageview']);

    (function() {
      var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
      ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
      var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
    })();
  </script>


</head>

<body   >
  <header role="banner"><hgroup>
  <h1><a href="/">Space Vatican</a></h1>
  
    <h2>Ramblings of a curious coder</h2>
  
</hgroup>

</header>
  <nav role="navigation"><ul class="subscription" data-subscription="rss">
  <li><a href="/atom.xml" rel="subscribe-rss" title="subscribe via RSS">RSS</a></li>
  
</ul>
  
<form action="https://google.com/search" method="get">
  <fieldset role="search">
    <input type="hidden" name="q" value="site:www.spacevatican.org" />
    <input class="search" type="text" name="q" results="0" placeholder="Search"/>
  </fieldset>
</form>
  
<ul class="main-navigation">
  <li><a href="/">Blog</a></li>
  <li><a href="/blog/archives/">Archives</a></li>
</ul>

</nav>
  <div id="main">
    <div id="content">
      <div class="blog-index">
  
  
  
    <article>
      
  <header>
    
      <h1 class="entry-title"><a href="/2022/11/4/dependabot-and-tapioca">Updating Dependabot PRs With Tapioca</a></h1>
    
    
      <p class="meta">
        








  


<time datetime="2022-11-04T12:07:44+00:00" pubdate data-updated="true">Nov 4<span>th</span>, 2022</time>
        
      </p>
    
  </header>


  <div class="entry-content"><p>I&rsquo;ve been using <a href="https://sorbet.org/">sorbet</a> recently on a project. If you haven&rsquo;t come across it before, sorbet is a type checker for ruby that allows you to gradually add type annotations to your codebase (sigs in sorbet terminology) and then provide feedback (either on the command-line or in your editor) when things don&rsquo;t check out.</p>

<p>As well as the sigs you add to your source, sorbet supports <code>rbi</code> files for describing your classes. In particular these are key for describing your dependencies. The recommended way is to use <a href="https://github.com/Shopify/tapioca">tapioca</a>, a tool released by Shopify, for generating rbis. One of the things tapioca will do is autogenerate rbis for all of the gems you use. These autogenerated ones aren&rsquo;t super smart (effectively just method name + number of arguments), but a lot better than nothing (there are also handwritten ones known as annotations - this is a small and nascent collection compared to typescript&rsquo;s definitelytyped).</p>

<p>Of course, as your change or update your gems, the corresponding rbis need to be updated. If you run <code>tapioca gem --verify</code> then it will tell you whether there are any out of date gem rbis. We&rsquo;ve added this to our CI to check that they&rsquo;re always in sync. So far, so good! However we also use dependabot to manage our dependencies, so now every dependabot gem update PR would fail on CI, until someone came along and ran <code>tapioca gem</code>. This doesn&rsquo;t take long (I wrote a shell alias to run bundler, run tapioca and then commit and push the results) but it&rsquo;s an extra manual step and dependabot is all about removing manual steps.</p>

</div>
  
  
    <footer>
      <a rel="full-article" href="/2022/11/4/dependabot-and-tapioca">Read on &rarr;</a>
    </footer>
  


    </article>
  
  
    <article>
      
  <header>
    
      <h1 class="entry-title"><a href="/2020/11/28/ruby-layers">AWS Lambda Layers and Ruby</a></h1>
    
    
      <p class="meta">
        








  


<time datetime="2020-11-28T18:50:07+00:00" pubdate data-updated="true">Nov 28<span>th</span>, 2020</time>
        
      </p>
    
  </header>


  <div class="entry-content"><p>I&rsquo;ve been building a few things using lambda functions in ruby recently. Some of these are just standalone functions, some end up as more complicated stacks, with multiple functions working together, usually with a lot of common dependencies.</p>

<p>This was annoying to work with since on each <code>sam build</code> invocation bundler was redownloading &amp; reinstalling these dependencies for each function,
even if you had only changed one of the functions. By the time I got to 4-5 functions in a stack it was really starting to slow down that fast iteration
that is so beneficial. This got me thinking - could I put the vendored bundle in a layer that was used by all my functions?</p>

</div>
  
  
    <footer>
      <a rel="full-article" href="/2020/11/28/ruby-layers">Read on &rarr;</a>
    </footer>
  


    </article>
  
  
    <article>
      
  <header>
    
      <h1 class="entry-title"><a href="/2019/7/6/brighton-ruby-2019">Brighton Ruby 2019</a></h1>
    
    
      <p class="meta">
        








  


<time datetime="2019-07-06T19:05:35+01:00" pubdate data-updated="true">Jul 6<span>th</span>, 2019</time>
        
      </p>
    
  </header>


  <div class="entry-content"><p>I was lucky enough to attend Brighton Ruby 2019 as a speaker this year, but that didn&rsquo;t stop me from enjoying the other great talks. Maybe this summary will be useful when your boss asks you what you learned, which conferences videos to look forward to or just as a helping hand to remember a great day in Brighton.</p>

</div>
  
  
    <footer>
      <a rel="full-article" href="/2019/7/6/brighton-ruby-2019">Read on &rarr;</a>
    </footer>
  


    </article>
  
  
    <article>
      
  <header>
    
      <h1 class="entry-title"><a href="/2019/5/4/debugging-a-memory-leak-in-a-rails-app">Debugging a Memory Leak in a Rails App</a></h1>
    
    
      <p class="meta">
        








  


<time datetime="2019-05-04T08:46:08+01:00" pubdate data-updated="true">May 4<span>th</span>, 2019</time>
        
      </p>
    
  </header>


  <div class="entry-content"><p>I got a series of Rollbar alerts a few days ago: <code>NoMemoryError: failed to allocate memory</code>. The application wasn&rsquo;t under any particular load at the time, and a quick look at memory usage stats in appsignal showed the telltale signs of a memory leak: slowly but inevitably rising memory usage.</p>

</div>
  
  
    <footer>
      <a rel="full-article" href="/2019/5/4/debugging-a-memory-leak-in-a-rails-app">Read on &rarr;</a>
    </footer>
  


    </article>
  
  
    <article>
      
  <header>
    
      <h1 class="entry-title"><a href="/2019/2/2/capistrano-filters">Dynamic Filters With Capistrano 3</a></h1>
    
    
      <p class="meta">
        








  


<time datetime="2019-02-02T19:26:08+00:00" pubdate data-updated="true">Feb 2<span>nd</span>, 2019</time>
        
      </p>
    
  </header>


  <div class="entry-content"><p>I&rsquo;ve been updating some old deploy scripts from Capistrano 2 to Capistrano 3 recently. Needless to say, although superficially similar, a lot has changed under the hood (largely for the better. Capistrano 3 is in many ways a simpler, more predictable animal than its predecessor).</p>

<p>One change that bit me today is how filters work. In Capistrano 2, this was handled by environment variables such as <code>HOSTS</code> and <code>ROLES</code>. Capistrano 3 also add other ways of doing, such as via <code>set :filter</code>. The big difference is that Capistrano 3 creates its filter set <em>once</em>, whereas Capistrano 2 refiltered the hosts for a role everytime it fetched a list of hosts. This definitely makes things a lot simpler, but interferes with the tasks I have for doing rolling upgrades.</p>

<p>With Capistrano 2 I did this by updating the code on all the servers and then running the symlink and restart tasks on one host at a time, using HOSTS
for each one. One way around it would be to just reimplement the symlink and restart tasks ourselves, call it in our own <code>on</code> block, and make on process the hosts in sequence. As ever though, I&rsquo;m loath to reinvent the wheel.</p>

<p>A new concept in Capistrano 3 is that of custom filters, to allow you to expand on the HOSTS and ROLES filtering previously offered. This can be used with the task at hand: although the list of filters is static, Capistrano 3 does re-evaluate the list of servers against the filters with each call to <code>roles</code>. All that is needed is a filter that is reconfigurable. A filter is just an object with a public filter method. In all the examples an instance of a filter class is created wrapping the particular values that should be filtered, but it works just as well if the object passed to <code>add_filter</code> is the class itself:</p>

<figure class='code'><figcaption><span></span></figcaption><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
<span class='line-number'>6</span>
<span class='line-number'>7</span>
<span class='line-number'>8</span>
<span class='line-number'>9</span>
<span class='line-number'>10</span>
<span class='line-number'>11</span>
<span class='line-number'>12</span>
<span class='line-number'>13</span>
<span class='line-number'>14</span>
<span class='line-number'>15</span>
<span class='line-number'>16</span>
<span class='line-number'>17</span>
<span class='line-number'>18</span>
<span class='line-number'>19</span>
<span class='line-number'>20</span>
<span class='line-number'>21</span>
<span class='line-number'>22</span>
</pre></td><td class='code'><pre><code class='ruby'><span class='line'><span class="k">class</span> <span class="nc">DynamicHostFilter</span>
</span><span class='line'>
</span><span class='line'>  <span class="k">def</span> <span class="nc">self</span><span class="o">.</span><span class="nf">with_hosts</span> <span class="n">hosts</span>
</span><span class='line'>    <span class="n">old</span> <span class="o">=</span> <span class="vi">@hostnames</span>
</span><span class='line'>
</span><span class='line'>    <span class="n">common</span> <span class="o">=</span> <span class="o">[</span><span class="n">hosts</span><span class="p">,</span> <span class="n">old</span><span class="o">].</span><span class="n">compact</span><span class="o">.</span><span class="n">reduce</span><span class="p">(</span><span class="ss">:&amp;</span><span class="p">)</span>
</span><span class='line'>    <span class="k">begin</span>
</span><span class='line'>      <span class="vi">@hostnames</span> <span class="o">=</span> <span class="n">common</span>
</span><span class='line'>      <span class="k">yield</span>
</span><span class='line'>    <span class="k">ensure</span>
</span><span class='line'>      <span class="vi">@hostnames</span> <span class="o">=</span> <span class="n">old</span>
</span><span class='line'>    <span class="k">end</span>
</span><span class='line'>  <span class="k">end</span>
</span><span class='line'>
</span><span class='line'>  <span class="k">def</span> <span class="nc">self</span><span class="o">.</span><span class="nf">filter</span><span class="p">(</span><span class="n">servers</span><span class="p">)</span>
</span><span class='line'>    <span class="k">if</span> <span class="vi">@hostnames</span>
</span><span class='line'>      <span class="n">servers</span><span class="o">.</span><span class="n">select</span> <span class="p">{</span><span class="o">|</span><span class="n">s</span><span class="o">|</span> <span class="vi">@hostnames</span><span class="o">.</span><span class="n">include?</span><span class="p">(</span><span class="n">s</span><span class="o">.</span><span class="n">hostname</span><span class="p">)</span> <span class="p">}</span>
</span><span class='line'>    <span class="k">else</span>
</span><span class='line'>      <span class="n">servers</span>
</span><span class='line'>    <span class="k">end</span>
</span><span class='line'>  <span class="k">end</span>
</span><span class='line'><span class="k">end</span>
</span></code></pre></td></tr></table></div></figure>


<p>All this is a class with a class instance variable containing a list of hosts that it uses to filter servers. The <code>with_hosts</code> method allows us to set the filter for the duration of the block. Any new filter is intersected with existing filters and removed at the end of the block, which I think reduces the possibility for surprising behaviour. The rolling restart code is then just</p>

<figure class='code'><figcaption><span></span></figcaption><div class="highlight"><table><tr><td class="gutter"><pre class="line-numbers"><span class='line-number'>1</span>
<span class='line-number'>2</span>
<span class='line-number'>3</span>
<span class='line-number'>4</span>
<span class='line-number'>5</span>
</pre></td><td class='code'><pre><code class='ruby'><span class='line'>  <span class="n">on</span><span class="p">(</span> <span class="n">roles</span><span class="p">(</span><span class="ss">:app</span><span class="p">),</span> <span class="k">in</span><span class="p">:</span> <span class="ss">:sequence</span><span class="p">,</span> <span class="ss">wait</span><span class="p">:</span> <span class="mi">5</span><span class="p">)</span> <span class="k">do</span> <span class="o">|</span><span class="n">host</span><span class="o">|</span>
</span><span class='line'>    <span class="no">DynamicHostFilter</span><span class="o">.</span><span class="n">with_hosts</span><span class="p">(</span><span class="o">[</span><span class="n">host</span><span class="o">.</span><span class="n">hostname</span><span class="o">]</span><span class="p">)</span> <span class="k">do</span>
</span><span class='line'>      <span class="c1">#handle this host</span>
</span><span class='line'>    <span class="k">end</span>
</span><span class='line'>  <span class="k">end</span>
</span></code></pre></td></tr></table></div></figure>


<p>which is actually a lot nicer than the old Capistrano 2 code it replaced.</p>
</div>
  
  


    </article>
  
  <div class="pagination">
    
      <a class="prev" href="/blog/page/2/">&larr; Older</a>
    
    <a href="/blog/archives">Blog Archives</a>
    
  </div>
</div>
<aside class="sidebar">
  <section>
    <h1>About</h1>
    <a href="/about-me.html">Me</a>
  </section>
  
    <section>
  <h1>Recent Posts</h1>
  <ul id="recent_posts">
    
      <li class="post">
        <a href="/2022/11/4/dependabot-and-tapioca">Updating Dependabot PRs with tapioca</a>
      </li>
    
      <li class="post">
        <a href="/2020/11/28/ruby-layers">AWS Lambda Layers and Ruby</a>
      </li>
    
      <li class="post">
        <a href="/2019/7/6/brighton-ruby-2019">Brighton Ruby 2019</a>
      </li>
    
      <li class="post">
        <a href="/2019/5/4/debugging-a-memory-leak-in-a-rails-app">Debugging a memory leak in a Rails app</a>
      </li>
    
      <li class="post">
        <a href="/2019/2/2/capistrano-filters">Dynamic filters with Capistrano 3</a>
      </li>
    
  </ul>
</section>


<section>
<a class="twitter-timeline" href="https://twitter.com/fglc2" data-widget-id="364498458968739840" data-chrome="nofooter transparent">Tweets by @fglc2</a>
<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+"://platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);}}(document,"script","twitter-wjs");</script>
</section>



<section class="googleplus googleplus-hidden">
  <h1>
    <a href="https://plus.google.com/102772350253089126412?rel=author">
      <img src="https://www.google.com/images/icons/ui/gprofile_button-32.png" width="32" height="32">
      Google+
    </a>
  </h1>
</section>



<section>
  <h1>Stack Overflow Answers</h1>
  <ul id="stackoverflow">
    <li class="loading">Answers updating&#8230;</li>
  </ul>
  <script type="text/javascript">
    $.domReady(function(){
      getStackOverflowFeed("1064226", 4);
    });
  </script>
  <script src="/javascripts/stackoverflow.js" type="text/javascript"> </script>
</section>


  
</aside>

    </div>
  </div>
  <footer role="contentinfo"><p>
  Copyright &copy; 2022 - Frederick Cheung -
  <span class="credit">Powered by <a href="http://octopress.org">Octopress</a></span>
</p>

</footer>
  







  <script type="text/javascript">
    (function(){
      var twitterWidgets = document.createElement('script');
      twitterWidgets.type = 'text/javascript';
      twitterWidgets.async = true;
      twitterWidgets.src = 'https://platform.twitter.com/widgets.js';
      document.getElementsByTagName('head')[0].appendChild(twitterWidgets);
    })();
  </script>





</body>
</html>
